
#include "1874VE7T_HSO.h"

#define ADDRHSO_NUM     0xA000
#define ADDRHSO_STAT    0xA010
#define ADDRHSO_TIME    0xA020
#define EXTMEM(X)    *(volatile short*)(X)

#define BeginHWindow    tmp=WSR;
#define SetHWindow1     WSR=0x01;
#define SetHWindow15    WSR=0x0F;
#define SetHWindow0     WSR=0;
#define EndHWindow      WSR=tmp;

#pragma interrupt 0  IRQ_timer2
#pragma interrupt 11  IRQ_timer2_cap

//#pragma interrupt 0  IRQ_timer1
#pragma interrupt 3  IRQ_HSO

void HSO_ADD_EVENT(HSO_EventTypeDef *HSO_Event)
{
   unsigned char tmp,tmp1;
   tmp1 = WSR;
   WSR = 0x0;
   if (!(IOS0 & 0x40))
   {   
   // HSO_COMMAND
//   tmp = HSO_Event->Command & 0x0F;
     if (HSO_Event->Channel == HSO_All_Channels) tmp = HSO_CMD_HSOALL;
     else if (HSO_Event->Channel == HSO_Channel_0) tmp = HSO_CMD_HSO0;
     else if (HSO_Event->Channel == HSO_Channel_1) tmp = HSO_CMD_HSO1;
     else if (HSO_Event->Channel == HSO_Channel_2) tmp = HSO_CMD_HSO2;
     else if (HSO_Event->Channel == HSO_Channel_3) tmp = HSO_CMD_HSO3;
     else if (HSO_Event->Channel == HSO_Channel_4) tmp = HSO_CMD_HSO4;
     else if (HSO_Event->Channel == HSO_Channel_5) tmp = HSO_CMD_HSO5;

     if (HSO_Event->Interrupt_EN == ENABLE) tmp |= 0x10;
     tmp |= HSO_Event->Pin_State;
     tmp |= HSO_Event->TimerSel;
	 if (HSO_Event->CAM_Lock == ENABLE) tmp |= 0x80;
     HSO_COMMAND = tmp;
     HSO_TIME = HSO_Event->Time;
   }
   WSR = tmp1;
}

void HSO_Init(HSO_InitTypeDef *HSO_StructInit)
{
  unsigned char tmp,tmp1;
  tmp = WSR;
  if (HSO_StructInit->Interrupt_EN == ENABLE) INT_MASK |= 0x08; //HSO_MASK = 1
  if ((HSO_StructInit->Channels & HSO_Channel_0) | (HSO_StructInit->Channels & HSO_Channel_1))
  {
    WSR = 0x0F;
    tmp1 = IOC1;
    tmp1 |= 0x10;
    WSR = 0x0;
    IOC1 = tmp1;
  }
  if ((HSO_StructInit->Channels & HSO_Channel_2) | (HSO_StructInit->Channels & HSO_Channel_4))
  {
    WSR = 0x0F;
    tmp1 = IOC1;
    tmp1 |= 0x40;
    WSR = 0x0;
    IOC1 = tmp1;
  }
  if (HSO_StructInit->Channels & HSO_Channel_5)
  {
    WSR = 0x0F;
    tmp1 = IOC1;
    tmp1 &= 0xFE;
    WSR = 0x0;
    IOC1 = tmp1;
  }
  WSR = tmp;
}

void HSO_CAM_Clear()
{
   unsigned char tmp,tmp1;
   tmp = WSR;
   WSR = 0x0F;
   tmp1 = IOC2;
   tmp1 &= 0x7F;
   WSR = 0;
   IOC2 = tmp1;
   WSR = tmp;
}

void HSO_Commands_Lock(unsigned char NewState)
{
   unsigned char tmp,tmp1;
   tmp = WSR;
   WSR = 0x0F;
   tmp1 = IOC2;
   if (NewState == ENABLE) tmp1 |= 0x40;
   else tmp1 &= 0xBF;
   WSR = 0;
   IOC2 = tmp1;
   WSR = tmp;
}

void Timer1_Init(void)
{
   unsigned char tmp;
   unsigned char oldIOC1;

   INT_MASK |= 0x1;
   BeginHWindow
   SetHWindow15
//   TIMER1 = T1Fill;
   TIMER1 = 0x4000;
   oldIOC1 = IOC1;
   oldIOC1 |= 0x04;  //T1OVF_INT - 2 bit
   SetHWindow0
//   IOC1_Bits.T1OVF_INT = 1;
   IOC1 = oldIOC1;
   EndHWindow
}


void Timer2_Init(void)
{
   unsigned char tmp;
   unsigned char ch_reg;
   INT_MASK |= 0x1;
   //INT_MASK1 |= 0x10;
   BeginHWindow
   SetHWindow1
   IOC3 |= 0x1; //T2_ENA = 1   
   SetHWindow15
   ch_reg = IOC1;
   SetHWindow0
   ch_reg |= 0x8; //T2OVF_INT = 1
   IOC1 = ch_reg;
   TIMER2 = 0x3FF0;
   EndHWindow
}

/*
  HSO_Event.Channel = HSO_All_Channels;
  HSO_Event.Time = 0x4000;
  HSO_Event.Pin_State = HSO_PIN_HIGH;
  HSO_Event.TimerSel = HSO_Timer2;
  HSO_Event.CAM_Lock = DISABLE;
  HSO_Event.Interrupt_EN = DISABLE;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Time = 0x4010;
  HSO_Event.Channel = HSO_All_Channels;
  HSO_Event.Pin_State = HSO_PIN_LOW;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Channel = HSO_All_Channels;
  HSO_Event.Time = 0x5000;
  HSO_Event.Pin_State = HSO_PIN_HIGH;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Interrupt_EN = ENABLE;
  HSO_Event.Channel = HSO_All_Channels;
  HSO_Event.Time = 0x5010;
  HSO_Event.Pin_State = HSO_PIN_LOW;
  HSO_ADD_EVENT(&HSO_Event);
*/

void SetEvents()
{
  HSO_EventTypeDef HSO_Event;

// Phase 0

  HSO_Event.Channel = HSO_Channel_0;
  HSO_Event.Time = 0x4000;
  HSO_Event.Pin_State = HSO_PIN_HIGH;
  HSO_Event.TimerSel = HSO_Timer2;
  HSO_Event.CAM_Lock = DISABLE;
  HSO_Event.Interrupt_EN = DISABLE;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Time = 0x4400;
  HSO_Event.Channel = HSO_Channel_0;
  HSO_Event.Pin_State = HSO_PIN_LOW;
  HSO_ADD_EVENT(&HSO_Event);

// Phase 1

  HSO_Event.Time = 0x4400;
  HSO_Event.Channel = HSO_Channel_2;
  HSO_Event.Pin_State = HSO_PIN_HIGH;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Time = 0x4800;
  HSO_Event.Channel = HSO_Channel_2;
  HSO_Event.Pin_State = HSO_PIN_LOW;
  HSO_ADD_EVENT(&HSO_Event);

// Phase 2

  HSO_Event.Time = 0x4800;
  HSO_Event.Channel = HSO_Channel_4;
  HSO_Event.Pin_State = HSO_PIN_HIGH;
  HSO_ADD_EVENT(&HSO_Event);

  HSO_Event.Interrupt_EN = ENABLE;
  HSO_Event.Channel = HSO_Channel_4;
  HSO_Event.Time = 0x4C00;
  HSO_Event.Pin_State = HSO_PIN_LOW;
  HSO_ADD_EVENT(&HSO_Event);

}

int main()
{
  HSO_InitTypeDef HSO_StructInit;

   __EI();

  HSO_StructInit.Channels = HSO_All_Channels;
  HSO_StructInit.Interrupt_EN = ENABLE;
  HSO_Init(&HSO_StructInit);
  HSO_CAM_Clear();
  HSO_Commands_Lock(DISABLE);

  SetEvents();

  Timer2_Init();

  while(1);
  return 0;
}

void IRQ_timer2()
{
   unsigned char tmp;
   tmp = WSR;
   WSR = 0x0;
      TIMER2 = 0x4000;
   WSR = tmp;
}

void IRQ_timer2_cap()
{
  __NOP;
  __NOP;
}

//#pragma interrupt 0  IRQ_timer1
void IRQ_HSO()
{
   unsigned char tmp,tmp1;
   HSO_EventTypeDef HSO_Event;
   tmp = WSR;
   WSR = 0x0;
//   tmp1 = IOS2;
   EXTMEM(ADDRHSO_STAT) =  IOS2;
   if (TIMER2 > 0x4C00)
   {
    SetEvents();
     TIMER2 = 0x3FF0;
   }
   WSR = tmp;
}



